using System.Collections;
using System.Diagnostics;
using System.Resources;
using System.Text;
using System.Windows.Forms;
using Microsoft.Web.WebView2.Core;

namespace EdgeVoyager
{
    public partial class Form1 : Form
    {
        int zoom = 100;
        private bool isWebView2Focused = false;
        private HttpClient httpClient = new HttpClient();
        public Form1()
        {
            InitializeComponent();
            InitializeAsync();
        }

        private void CoreWebView2_NewWindowRequested(object sender, CoreWebView2NewWindowRequestedEventArgs e)
        {
            Form1 newForm = new Form1();
            newForm.webView21.Source = new Uri(e.Uri);
            newForm.Show();

            e.Handled = true;
        }

        async void InitializeAsync()
        {
            await webView21.EnsureCoreWebView2Async(null);
            string resxFilePath = "favoritesMenuItem.resx";
            using (ResXResourceReader reader = new ResXResourceReader(resxFilePath))
            {
                foreach (DictionaryEntry entry in reader)
                {
                    string resourceName = entry.Key.ToString();
                    string resourceValue = entry.Value.ToString();
                    ToolStripMenuItem menuItem = new ToolStripMenuItem
                    {
                        Text = resourceName,
                        Tag = resourceValue
                    };
                    menuItem.Click += MenuItem_Click;
                    ղؼAToolStripMenuItem.DropDownItems.Add(menuItem);
                }
            }
            webView21.CoreWebView2.WebResourceRequested += WebView2_WebResourceRequested;
            await webView21.CoreWebView2.ExecuteScriptAsync("window.onload=function(){window.chrome.webview.postMessage('100');};");
            webView21.CoreWebView2.Profile.PreferredColorScheme = CoreWebView2PreferredColorScheme.Light;
            webView21.CoreWebView2.NewWindowRequested += CoreWebView2_NewWindowRequested;
            webView21.GotFocus += (s, e) => isWebView2Focused = true;
            webView21.LostFocus += (s, e) => isWebView2Focused = false;
            if (Settings1.Default.firstwindow == true)
            {
                string htmlString = @"<!DOCTYPE html>
<html lang=""zh-CN"">
<head>
    <meta charset=""UTF-8"">
    <meta name=""viewport"" content=""width=device-width, initial-scale=1.0"">
    <title>ʼҳ</title>
    <style>
        body {
            margin: 0;
            padding: 0;
            background-image: url('https://www.beijing.gov.cn/images/index_top_ch_20190924.jpg');
            background-size: cover;
            background-repeat: no-repeat;
background-position: right top;
            background-attachment: fixed;
            font-family: Arial, sans-serif;
        }
        .header {
            background-color: rgba(255, 255, 255, 0.8);
            backdrop-filter: blur(10px);
            padding: 10px 20px;
            display: flex;
            align-items: center;
            position: relative;
            box-shadow: 0 2px 10px rgba(0, 0, 0, 0.1);
        }
        .logo {
            width: 48px;
            height: 48px;
        }
        .nav-item {
            margin-left: 20px;
            color: #333;
            text-decoration: none;
            font-size: 16px;
        }
        .nav-links {
            display: flex;
            align-items: center;
        }
        .welcome-text {
            text-align: center;
            margin: 20px 0;
            font-size: 36px;
            font-weight: bold;
            color: #0078D4;
        }
        .search-container {
            display: flex;
            justify-content: center;
            align-items: center;
            margin-top: 20px;
            border-radius: 15px;
            overflow: hidden;
        }
        .search-input {
            width: 70vw;
            max-width: 1000px;
            padding: 10px;
            font-size: 16px;
            border: none;
            border-radius: 15px 0 0 15px;
            height: 20px;
        }
        .search-button {
            padding: 10px 20px;
            width: 80px;
            font-size: 16px;
            cursor: pointer;
            border: none;
            background-color: #0078D4;
            color: white;
            border-radius: 0 15px 15px 0;
            height: 40px;
        }
        .search-engine-select {
            margin-left: 0px;
            padding: 10px;
            font-size: 16px;
            border: none;
            border-radius: 0px;
            background-color: #f2f2f2;
            cursor: pointer;
        }
        .acrylic-panel {
            background-color: rgba(255, 255, 255, 0.8);
            backdrop-filter: blur(10px);
            padding: 20px;
            border-radius: 8px;
            box-shadow: 0 4px 20px rgba(0, 0, 0, 0.2);
            margin: 20px 0;
            width: 90vw;
            margin-left: auto;
            margin-right: auto;
            max-width: 1200px;
        }
        @media (max-width: 600px) {
            .search-button {
                padding: 8px 16px;
            }
        }
    </style>
</head>
<body>
    <div class=""header"">
        <svg class=""logo"" xmlns=""http://www.w3.org/2000/svg"" viewBox=""0 0 48 48"">
            <linearGradient id=""Z3u55as5xQT0Xm3pZ~tHna"" x1=""27.702"" x2=""35.722"" y1=""18.41"" y2=""26.008"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#0e5fa4""/>
                <stop offset=""1"" stop-color=""#1595df""/>
            </linearGradient>
            <path fill=""url(#Z3u55as5xQT0Xm3pZ~tHna)"" d=""M24,6l18,16v17.586c0,0.891-1.077,1.337-1.707,0.707L24,24V6z""/>
            <linearGradient id=""Z3u55as5xQT0Xm3pZ~tHnb"" x1=""16.667"" x2=""22.667"" y1=""27"" y2=""27"" gradientTransform=""matrix(-3 0 0 -1 92 42)"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#50e6ff""/>
                <stop offset=""1"" stop-color=""#32bdef""/>
            </linearGradient>
            <path fill=""url(#Z3u55as5xQT0Xm3pZ~tHnb)"" d=""M24,6l18,16c-7.249-2.341-14-2-18,2V6z""/>
            <linearGradient id=""Z3u55as5xQT0Xm3pZ~tHnc"" x1=""18.483"" x2=""27.736"" y1=""19.517"" y2=""10.264"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#0e5fa4""/>
                <stop offset=""1"" stop-color=""#1595df""/>
            </linearGradient>
            <path fill=""url(#Z3u55as5xQT0Xm3pZ~tHnc)"" d=""M6,24L22,6h17.586c0.891,0,1.337,1.077,0.707,1.707L24,24H6z""/>
            <linearGradient id=""Z3u55as5xQT0Xm3pZ~tHnd"" x1=""3"" x2=""9"" y1=""24"" y2=""24"" gradientTransform=""matrix(0 3 -1 0 39 -3)"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#50e6ff""/>
                <stop offset=""1"" stop-color=""#32bdef""/>
            </linearGradient>
            <path fill=""url(#Z3u55as5xQT0Xm3pZ~tHnd)"" d=""M6,24L22,6c-2.341,7.249-2,14,2,18H6z""/>
            <linearGradient id=""Z3u55as5xQT0Xm3pZ~tHne"" x1=""19.748"" x2=""7.491"" y1=""29.748"" y2=""17.491"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#0e5fa4""/>
                <stop offset=""1"" stop-color=""#1595df""/>
            </linearGradient>
            <path fill=""url(#Z3u55as5xQT0Xm3pZ~tHne)"" d=""M24,42L6,26V8.414c0-0.891,1.077-1.337,1.707-0.707L24,24V42z""/>
            <linearGradient id=""Z3u55as5xQT0Xm3pZ~tHnf"" x1=""6"" x2=""12"" y1=""33"" y2=""33"" gradientTransform=""matrix(3 0 0 1 -12 0)"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#50e6ff""/>
                <stop offset=""1"" stop-color=""#32bdef""/>
            </linearGradient>
            <path fill=""url(#Z3u55as5xQT0Xm3pZ~tHnf)"" d=""M24,42L6,26c7.249,2.341,14,2,18-2V42z""/>
            <linearGradient id=""Z3u55as5xQT0Xm3pZ~tHng"" x1=""28.457"" x2=""19.623"" y1=""29.543"" y2=""38.377"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#0e5fa4""/>
                <stop offset=""1"" stop-color=""#1595df""/>
            </linearGradient>
            <path fill=""url(#Z3u55as5xQT0Xm3pZ~tHng)"" d=""M24,24L7.707,40.293C7.077,40.923,7.523,42,8.414,42H26l7.529-8.471L24,24z""/>
            <linearGradient id=""Z3u55as5xQT0Xm3pZ~tHnh"" x1=""24"" x2=""33.529"" y1=""33"" y2=""33"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#50e6ff""/>
                <stop offset=""1"" stop-color=""#32bdef""/>
            </linearGradient>
            <path fill=""url(#Z3u55as5xQT0Xm3pZ~tHnh)"" d=""M33.529,33.529L24,24c4,4,4.341,10.751,2,18L33.529,33.529z""/>
            <linearGradient id=""Z3u55as5xQT0Xm3pZ~tHni"" x1=""24.517"" x2=""23.183"" y1=""24.517"" y2=""23.183"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#ffd000""/>
                <stop offset=""1"" stop-color=""#fede00""/>
            </linearGradient>
            <circle cx=""24"" cy=""24"" r=""2"" fill=""url(#Z3u55as5xQT0Xm3pZ~tHni)""/>
        </svg>
        <span style=""font-size: 24px; color: #333; margin-left: 10px;"">LYKNS</span>
        <div class=""nav-links"">
            <a href=""https://www.lykns.com.cn"" class=""nav-item"">վ</a>
            <a href=""https://its.lykns.com.cn"" class=""nav-item"">Ʒ</a>
            <a href=""https://dev.lykns.com.cn"" class=""nav-item"">Git </a>
            <a href=""https://survey.lykns.com.cn"" class=""nav-item"">ʾϵͳ</a>
        </div>
    </div>
    <div class=""acrylic-panel"">
        <div style=""text-align:center;"">
            <svg xmlns=""http://www.w3.org/2000/svg"" viewBox=""0 0 48 48"" width=""128"" height=""128"">
                <linearGradient id=""_EnvA6UXZqPqJP5nSvD1Ka"" x1=""12.209"" x2=""34.197"" y1=""42.462"" y2=""7.83"" gradientTransform=""matrix(1 0 0 -1 0 47.89)"" gradientUnits=""userSpaceOnUse"">
                    <stop offset=""0"" stop-color=""#737b80"" />
                    <stop offset="".473"" stop-color=""#686f74"" />
                    <stop offset=""1"" stop-color=""#575c61"" />
                </linearGradient>
                <path fill=""url(#_EnvA6UXZqPqJP5nSvD1Ka)"" d=""M44,24c0,11.044-8.956,20-20,20S4,35.044,4,24S12.956,4,24,4S44,12.956,44,24z"" />
                <linearGradient id=""_EnvA6UXZqPqJP5nSvD1Kb"" x1=""16.956"" x2=""31.044"" y1=""37.138"" y2=""10.642"" gradientTransform=""matrix(1 0 0 -1 0 47.89)"" gradientUnits=""userSpaceOnUse"">
                    <stop offset=""0"" stop-color=""#ccc"" />
                    <stop offset="".758"" stop-color=""#f2f2f2"" />
                    <stop offset=""1"" stop-color=""#fff"" />
                </linearGradient>
                <path fill=""url(#_EnvA6UXZqPqJP5nSvD1Kb)"" d=""M39,24c0,8.287-6.713,15-15,15S9,32.287,9,24S15.713,9,24,9S39,15.713,39,24z"" />
                <linearGradient id=""_EnvA6UXZqPqJP5nSvD1Kc"" x1=""19.774"" x2=""28.226"" y1=""31.838"" y2=""15.942"" gradientTransform=""matrix(1 0 0 -1 0 47.89)"" gradientUnits=""userSpaceOnUse"">
                    <stop offset=""0"" stop-color=""#21ad64"" />
                    <stop offset=""1"" stop-color=""#088242"" />
                </linearGradient>
                <circle cx=""24"" cy=""24"" r=""9"" fill=""url(#_EnvA6UXZqPqJP5nSvD1Kc)"" />
            </svg>
        </div>
        <div class=""welcome-text"">
            ӭʹ LYKNS EdgeVoyager
        </div>
        <div class=""search-container"">
            <input type=""text"" id=""search-input"" class=""search-input"" placeholder=""..."">
            <select id=""search-engine-select"" class=""search-engine-select"">
                <option value=""bing"">Bing</option>
                <option value=""baidu"">ٶ</option>
                <option value=""google"">Google</option>
            </select>
            <button onclick=""search()"" class=""search-button""></button>
        </div>
    </div>
    <script>
        function search() {
            var query = document.getElementById('search-input').value;
            var engine = document.getElementById('search-engine-select').value;
            var url = '';
            if (engine === 'bing') {
                url = 'https://www.bing.com/search?q=' + encodeURIComponent(query);
            } else if (engine === 'baidu') {
                url = 'https://www.baidu.com/s?wd=' + encodeURIComponent(query);
            } else if (engine === 'google') {
                url = 'https://www.google.com/search?q=' + encodeURIComponent(query);
            }
            window.open(url, '_blank');
        }
    </script>
</body>
</html>";

                webView21.CoreWebView2.NavigateToString(htmlString);
                Settings1.Default.firstwindow = false;
                Settings1.Default.Save();
            }
        }

        private void back_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoBack();
        }

        private void forward_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoForward();
        }

        private void refresh_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Reload();
        }

        private void stop_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Stop();
        }

        private void search_button_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length > 0)
            {
                if (comboBox1.Text != "about:blank")
                {
                    Form1 newForm = new Form1();
                    newForm.webView21.Source = new Uri("https://cn.bing.com/search?q=" + textBox1.Text);
                    newForm.Show();
                }
                else
                {
                    webView21.CoreWebView2.Navigate("https://cn.bing.com/search?q=" + textBox1.Text);
                    webView21.CoreWebView2.Profile.PreferredColorScheme = CoreWebView2PreferredColorScheme.Light;
                }
            }
        }
        private bool isHttpsFallback = false;

        private void webView21_NavigationStarting(object sender, CoreWebView2NavigationStartingEventArgs e)
        {
            string uri = e.Uri;
            if (uri.StartsWith("http://"))
            {
                string httpsUri = "https://" + uri.Substring("http://".Length);
                e.Cancel = true; // ȡǰhttp
                webView21.CoreWebView2.Navigate(httpsUri); // https
            }
            string currentUrl = webView21.Source.ToString();
            if (!comboBox1.Items.Contains(currentUrl))
            {
                comboBox1.Items.Add(currentUrl);
            }
            comboBox1.Text = currentUrl;
            progressBar.Value = 0;
            progressLabel.Text = "0%";
            StatusLabel.Text = "ʼ" + currentUrl;
        }

        private async void webView21_NavigationCompleted(object sender, CoreWebView2NavigationCompletedEventArgs e)
        {
            if (!e.IsSuccess && isHttpsFallback)
            {
                isHttpsFallback = false; // ñ־
                string originalUri = webView21.CoreWebView2.Source.Replace("https://", "http://");
                webView21.CoreWebView2.Navigate(originalUri); // µhttpַ
            }
            else if (e.IsSuccess && webView21.CoreWebView2.Source.StartsWith("https://"))
            {
                isHttpsFallback = false; // httpsɹñ־
            }
            string currentUrl = webView21.Source.ToString();
            if (!comboBox1.Items.Contains(currentUrl))
            {
                comboBox1.Items.Add(currentUrl);
            }
            comboBox1.Text = currentUrl;
            progressBar.Value = 100;
            progressLabel.Text = "100%";
            StatusLabel.Text = "ɡ";
            string title = await webView21.CoreWebView2.ExecuteScriptAsync("document.title;");
            this.Text = "LYKNS EdgeVoyager" + title.Trim('"');

            string faviconUrl = await webView21.CoreWebView2.ExecuteScriptAsync("Array.from(document.querySelectorAll('link[rel=\"icon\"], link[rel=\"shortcut icon\"]')).map(link => link.href).find(url => url);");
            faviconUrl = faviconUrl.Trim('"');

            if (!string.IsNullOrEmpty(faviconUrl))
            {
                Uri uriResult;
                bool isAbsoluteUri = Uri.TryCreate(faviconUrl, UriKind.Absolute, out uriResult);

                if (isAbsoluteUri)
                {
                    using (var client = new HttpClient())
                    {

                        var faviconData = await client.GetByteArrayAsync(uriResult);
                        using (var ms = new MemoryStream(faviconData))
                        {
                            using (var img = Image.FromStream(ms))
                            {
                                if (img is Bitmap bitmap)
                                {
                                    this.Icon = Icon.FromHandle(bitmap.GetHicon());
                                }
                                else
                                {
                                    this.Icon = Icon.FromHandle(((Bitmap)img.Clone()).GetHicon());
                                }
                            }
                        }
                    }
                }
            }
        }

        private void comboBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                string input = comboBox1.Text;
                if (!input.StartsWith("http://") && !input.StartsWith("https://"))
                {
                    comboBox1.Text = "https://" + input;
                    comboBox1.SelectionStart = comboBox1.Text.Length;
                }
                string url = comboBox1.Text;
                if (Uri.IsWellFormedUriString(url, UriKind.Absolute))
                {
                    webView21.CoreWebView2.Navigate(url);
                }
            }
        }

        private void ˳XToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Environment.Exit(0);
        }

        private void webView21_ContentLoading(object sender, CoreWebView2ContentLoadingEventArgs e)
        {
            progressBar.Value = 50;
            progressLabel.Text = "50%";
            StatusLabel.Text = "ݿʼ";
        }
        private async void SetZoomLevel(double zoomLevel)
        {
            await webView21.CoreWebView2.ExecuteScriptAsync($"document.body.style.zoom = '{zoomLevel}%'");
        }

        private void toolStripSplitButton1_ButtonClick(object sender, EventArgs e)
        {
            SetZoomLevel(100);
            toolStripMenuItem3.Enabled = true;
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            zoom = zoom + 25;
            SetZoomLevel(zoom);
            toolStripMenuItem3.Enabled = true;
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            zoom = zoom - 25;
            SetZoomLevel(zoom);
            if (zoom == 25)
                toolStripMenuItem3.Enabled = false;
        }

        private void ˢRToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Reload();
        }

        private void ֹͣTToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Stop();
        }

        private void ǰQToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoForward();
        }

        private void WToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoBack();
        }

        private void webView21_SourceChanged(object sender, CoreWebView2SourceChangedEventArgs e)
        {
            StatusLabel.Text = "ԴַѸ";
        }

        private void WebView2_WebResourceRequested(object sender, CoreWebView2WebResourceRequestedEventArgs e)
        {
            string requestUri = e.Request.Uri;
            StatusLabel.Text = "Դ" + requestUri;
        }

        private void ToolStripMenuItem_CheckStateChanged(object sender, EventArgs e)
        {
            if (ToolStripMenuItem.Checked == true)
            {
                statusStrip1.Visible = true;
                webView21.Height = webView21.Height - 23;
            }
            else
            {
                statusStrip1.Visible = false;
                webView21.Height = webView21.Height + 23;
            }
        }

        private void EdgeVoyagerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 aboutBox1 = new AboutBox1();
            aboutBox1.ShowDialog();
        }

        private void ½NToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Settings1.Default.firstwindow = true;
            Settings1.Default.Save();
            Form1 newForm = new Form1();
            newForm.Show();
        }

        private void OToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "ҳļ (*.html;*.htm)|*.html;*.htm|ʸͼļ (*.svg)|*.svg|ļ (*.*)|*.*";
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                string filePath = openFileDialog.FileName;
                Form1 newForm = new Form1();
                newForm.webView21.Source = new Uri("file:///" + filePath);
                newForm.Show();
            }
        }

        private async void SToolStripMenuItem_ClickAsync(object sender, EventArgs e)
        {
        }

        private async void ӡPToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string title = webView21.CoreWebView2.DocumentTitle;
            try
            {
                CoreWebView2PrintStatus printStatus = await webView21.CoreWebView2.PrintAsync(null);
                if (printStatus == CoreWebView2PrintStatus.Succeeded)
                {
                    MessageBox.Show(this, "ӡ " + title + " ĵӡɹ", "ӡĬϴӡ");
                }
                else if (printStatus == CoreWebView2PrintStatus.PrinterUnavailable)
                {
                    MessageBox.Show(this, "ӡã߻״̬", "ӡĬϴӡ");
                }
                else
                {
                    MessageBox.Show(this, "ӡ " + title + " ĵӡʧ", "ӡĬϴӡ");
                }
            }
            catch (Exception)
            {
                MessageBox.Show(this, "ӡ " + title + " ĵڽ", "ӡĬϴӡ");
            }
        }

        private void ӡԤVToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.ShowPrintUI();
        }

        private void SToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string mailtoLink = $"mailto:?subject=ҳ&body=鿴ҳ" + comboBox1.Text;
            Process.Start(new ProcessStartInfo
            {
                FileName = mailtoLink,
                UseShellExecute = true
            });
        }

        private async void PToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string title = webView21.CoreWebView2.DocumentTitle;
            string url = webView21.CoreWebView2.Source;
            string content = await GetWebPageContent(url);
            int charCount = content.Length;
            int byteCount = Encoding.UTF8.GetByteCount(content);
            string encoding = "UTF-8";
            string language = "zh-CN";
            string contentType = "text/html";
            string author = await GetMetaData("author");
            string description = await GetMetaData("description");
            string keywords = await GetMetaData("keywords");
            string updateDate = await GetMetaData("last-modified");
            string securityInfo = await GetSecurityInfo(url);
            string securityLevel = "High";
            string faviconUrl = await GetFaviconUrl();
            string encodingLanguage = "HTML, JavaScript";
            MessageBox.Show(
                $"Ϣ\n" +
                $"⣺{title}\n" +
                $"ַURL{url}\n" +
                $"룺{encoding}\n" +
                $"ԣ{language}\n" +
                $"ͣ{contentType}\n" +
                $"\nҳϢ\n" +
                $"ַ{charCount}\n" +
                $"ֽ{byteCount}\n" +
                $"뷽ʽHTML, XML\n" +
                $"\nҳԪݣ\n" +
                $"ߣ{author}\n" +
                $"{description}\n" +
                $"ؼʣ{keywords}\n" +
                $"ڣ{updateDate}\n" +
                $"\nҳȫϢ\n" +
                $"ȫ֤Ϣ{securityInfo}\n" +
                $"ȫ{securityLevel}\n" +
                $"\nϢ\n" +
                $"ղؼͼ꣺{faviconUrl}\n" +
                $"ԣ{encodingLanguage}",
                "ҳ",
                MessageBoxButtons.OK,
                MessageBoxIcon.Information
            );
        }

        private async Task<string> GetWebPageContent(string url)
        {
            try
            {
                HttpResponseMessage response = await httpClient.GetAsync(url);
                response.EnsureSuccessStatusCode();
                return await response.Content.ReadAsStringAsync();
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        private async Task<string> GetMetaData(string name)
        {
            try
            {
                string script = $"document.querySelector('meta[name=\"{name}\"]').content;";
                return await webView21.CoreWebView2.ExecuteScriptAsync(script);
            }
            catch (Exception)
            {
                return "";
            }
        }

        private async Task<string> GetFaviconUrl()
        {
            try
            {
                string script = "Array.from(document.querySelectorAll('link[rel=\"icon\"], link[rel=\"shortcut icon\"]')).map(link => link.href).find(url => url);";
                string faviconUrl = await webView21.CoreWebView2.ExecuteScriptAsync(script);
                return faviconUrl.Trim('"');
            }
            catch (Exception)
            {
                return "";
            }
        }

        private async Task<string> GetSecurityInfo(string url)
        {
            try
            {
                HttpResponseMessage response = await httpClient.GetAsync(url);
                response.EnsureSuccessStatusCode();
                if (response.RequestMessage.RequestUri.Scheme == "https")
                {
                    var headers = response.Headers;
                    if (headers.Contains("Strict-Transport-Security"))
                    {
                        return "HSTSѿ";
                    }
                }
                return "HSTS";
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        private void TToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (comboBox1.Focused)
            {
                if (comboBox1.SelectedText != "")
                {
                    Clipboard.SetText(comboBox1.SelectedText);
                    comboBox1.Text = comboBox1.Text.Remove(comboBox1.SelectionStart, comboBox1.SelectionLength);
                    comboBox1.Focus();
                }
            }
            else if (textBox1.Focused)
            {
                if (textBox1.SelectedText != "")
                {
                    Clipboard.SetText(textBox1.SelectedText);
                    textBox1.Text = textBox1.Text.Remove(textBox1.SelectionStart, textBox1.SelectionLength);
                }
            }
        }

        private async void CToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (comboBox1.Focused)
            {
                if (comboBox1.SelectedText != "")
                {
                    Clipboard.SetText(comboBox1.SelectedText);
                }
            }
            else if (textBox1.Focused)
            {
                if (textBox1.SelectedText != "")
                {
                    Clipboard.SetText(textBox1.SelectedText);
                }
            }
            else if (isWebView2Focused)
            {
                string script = "window.getSelection().toString();";
                string selectedText = await webView21.CoreWebView2.ExecuteScriptAsync(script);
                selectedText = selectedText.Trim('"');
                if (!string.IsNullOrEmpty(selectedText))
                {
                    Clipboard.SetText(selectedText);
                }
            }
        }

        private async void ճPToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (comboBox1.Focused)
            {
                if (comboBox1.SelectionLength > 0)
                {
                    string clipboardText = Clipboard.GetText();
                    comboBox1.Text = comboBox1.Text.Remove(comboBox1.SelectionStart, comboBox1.SelectionLength) + clipboardText;
                    comboBox1.SelectionStart = comboBox1.Text.Length;
                }
                else
                {
                    string clipboardText = Clipboard.GetText();
                    comboBox1.Text += clipboardText;
                    comboBox1.SelectionStart = comboBox1.Text.Length;
                }
            }
            else if (textBox1.Focused)
            {
                textBox1.Paste();
            }

        }

        private async void ȫѡAToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (comboBox1.Focused)
            {
                comboBox1.SelectAll();
            }
            else if (textBox1.Focused)
            {
                textBox1.SelectAll();
            }
            else
            {
                string script = "document.execCommand('selectAll', false, null);";
                await webView21.CoreWebView2.ExecuteScriptAsync(script);
            }
        }

        private void FToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private async void ӵղؼToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string resxFilePath = "favoritesMenuItem.resx";
            string title = await webView21.CoreWebView2.ExecuteScriptAsync("document.title;");
            string pageTitle = title.Trim('"');
            string pageUrl = webView21.CoreWebView2.Source.ToString();
            bool titleExists = false;
            using (ResXResourceReader reader = new ResXResourceReader(resxFilePath))
            {
                foreach (DictionaryEntry entry in reader)
                {
                    if (entry.Key.ToString() == pageTitle)
                    {
                        titleExists = true;
                        break;
                    }
                }
            }
            if (!titleExists)
            {
                ResXResourceReader reader = new ResXResourceReader(resxFilePath);
                Hashtable resources = new Hashtable();
                foreach (DictionaryEntry entry in reader)
                {
                    resources.Add(entry.Key, entry.Value);
                }
                reader.Close();

                // µԴ
                resources.Add(pageTitle, pageUrl);

                // д뵽Դļ
                using (ResXResourceWriter writer = new ResXResourceWriter(resxFilePath))
                {
                    foreach (DictionaryEntry entry in resources)
                    {
                        writer.AddResource(entry.Key.ToString(), entry.Value);
                    }
                    writer.Generate();
                }
                for (int i = 0; i < ղؼAToolStripMenuItem.DropDownItems.Count; i++)
                {
                    // ҵtoolStripSeparator10
                    if (ղؼAToolStripMenuItem.DropDownItems[i] is ToolStripSeparator &&
                        ղؼAToolStripMenuItem.DropDownItems[i].Name == "toolStripSeparator10")
                    {
                        // toolStripSeparator10·ʼɾаť
                        for (int j = ղؼAToolStripMenuItem.DropDownItems.Count - 1; j > i; j--)
                        {
                            ղؼAToolStripMenuItem.DropDownItems.RemoveAt(j);
                        }
                        break; // ҵϺ˳ѭ
                    }
                }
                using (ResXResourceReader reader1 = new ResXResourceReader(resxFilePath))
                {
                    foreach (DictionaryEntry entry in reader1)
                    {
                        string resourceName = entry.Key.ToString();
                        string resourceValue = entry.Value.ToString();
                        ToolStripMenuItem menuItem = new ToolStripMenuItem
                        {
                            Text = resourceName,
                            Tag = resourceValue
                        };
                        menuItem.Click += MenuItem_Click;
                        ղؼAToolStripMenuItem.DropDownItems.Add(menuItem);
                    }
                }
            }
        }
        private async Task<byte[]> DownloadFaviconAsync(string faviconUrl)
        {
            using (HttpClient client = new HttpClient())
            {
                try
                {
                    return await client.GetByteArrayAsync(faviconUrl);
                }
                catch (Exception ex)
                {
                    return null;
                }
            }
        }
        private void MenuItem_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem menuItem = (ToolStripMenuItem)sender;
            string url = (string)menuItem.Tag;
            webView21.CoreWebView2.Navigate(url);
        }

        private void ղؼToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form2 form2 = new Form2();
            form2.ShowDialog();
            string resxFilePath = "favoritesMenuItem.resx";
            for (int i = 0; i < ղؼAToolStripMenuItem.DropDownItems.Count; i++)
            {
                // ҵtoolStripSeparator10
                if (ղؼAToolStripMenuItem.DropDownItems[i] is ToolStripSeparator &&
                    ղؼAToolStripMenuItem.DropDownItems[i].Name == "toolStripSeparator10")
                {
                    // toolStripSeparator10·ʼɾаť
                    for (int j = ղؼAToolStripMenuItem.DropDownItems.Count - 1; j > i; j--)
                    {
                        ղؼAToolStripMenuItem.DropDownItems.RemoveAt(j);
                    }
                    break; // ҵϺ˳ѭ
                }
            }
            using (ResXResourceReader reader1 = new ResXResourceReader(resxFilePath))
            {
                foreach (DictionaryEntry entry in reader1)
                {
                    string resourceName = entry.Key.ToString();
                    string resourceValue = entry.Value.ToString();
                    ToolStripMenuItem menuItem = new ToolStripMenuItem
                    {
                        Text = resourceName,
                        Tag = resourceValue
                    };
                    menuItem.Click += MenuItem_Click;
                    ղؼAToolStripMenuItem.DropDownItems.Add(menuItem);
                }
            }
        }

        private void Form1_Activated(object sender, EventArgs e)
        {
            string resxFilePath = "favoritesMenuItem.resx";
            for (int i = 0; i < ղؼAToolStripMenuItem.DropDownItems.Count; i++)
            {
                // ҵtoolStripSeparator10
                if (ղؼAToolStripMenuItem.DropDownItems[i] is ToolStripSeparator &&
                    ղؼAToolStripMenuItem.DropDownItems[i].Name == "toolStripSeparator10")
                {
                    // toolStripSeparator10·ʼɾаť
                    for (int j = ղؼAToolStripMenuItem.DropDownItems.Count - 1; j > i; j--)
                    {
                        ղؼAToolStripMenuItem.DropDownItems.RemoveAt(j);
                    }
                    break; // ҵϺ˳ѭ
                }
            }
            using (ResXResourceReader reader1 = new ResXResourceReader(resxFilePath))
            {
                foreach (DictionaryEntry entry in reader1)
                {
                    string resourceName = entry.Key.ToString();
                    string resourceValue = entry.Value.ToString();
                    ToolStripMenuItem menuItem = new ToolStripMenuItem
                    {
                        Text = resourceName,
                        Tag = resourceValue
                    };
                    menuItem.Click += MenuItem_Click;
                    ղؼAToolStripMenuItem.DropDownItems.Add(menuItem);
                }
            }
        }
    }
}
